/* FilterListEntry.c generated by valac 0.32.1, the Vala compiler
 * generated from FilterListEntry.vala, do not modify */

/*  This file is part of corebird, a Gtk+ linux Twitter client.
 *  Copyright (C) 2013 Timm Bäder
 *
 *  corebird is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  corebird is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with corebird.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include "CbFilter.h"
#include <rest/oauth-proxy.h>
#include "CbUserCounter.h"
#include <stdlib.h>
#include <string.h>
#include <sqlite3.h>


#define TYPE_FILTER_LIST_ENTRY (filter_list_entry_get_type ())
#define FILTER_LIST_ENTRY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_FILTER_LIST_ENTRY, FilterListEntry))
#define FILTER_LIST_ENTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_FILTER_LIST_ENTRY, FilterListEntryClass))
#define IS_FILTER_LIST_ENTRY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_FILTER_LIST_ENTRY))
#define IS_FILTER_LIST_ENTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_FILTER_LIST_ENTRY))
#define FILTER_LIST_ENTRY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_FILTER_LIST_ENTRY, FilterListEntryClass))

typedef struct _FilterListEntry FilterListEntry;
typedef struct _FilterListEntryClass FilterListEntryClass;
typedef struct _FilterListEntryPrivate FilterListEntryPrivate;

#define TYPE_ACCOUNT (account_get_type ())
#define ACCOUNT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ACCOUNT, Account))
#define ACCOUNT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ACCOUNT, AccountClass))
#define IS_ACCOUNT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ACCOUNT))
#define IS_ACCOUNT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ACCOUNT))
#define ACCOUNT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ACCOUNT, AccountClass))

typedef struct _Account Account;
typedef struct _AccountClass AccountClass;

#define TYPE_MAIN_WINDOW (main_window_get_type ())
#define MAIN_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MAIN_WINDOW, MainWindow))
#define MAIN_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MAIN_WINDOW, MainWindowClass))
#define IS_MAIN_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MAIN_WINDOW))
#define IS_MAIN_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MAIN_WINDOW))
#define MAIN_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MAIN_WINDOW, MainWindowClass))

typedef struct _MainWindow MainWindow;
typedef struct _MainWindowClass MainWindowClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _AccountPrivate AccountPrivate;

#define SQL_TYPE_DATABASE (sql_database_get_type ())
#define SQL_DATABASE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SQL_TYPE_DATABASE, SqlDatabase))
#define SQL_DATABASE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SQL_TYPE_DATABASE, SqlDatabaseClass))
#define SQL_IS_DATABASE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SQL_TYPE_DATABASE))
#define SQL_IS_DATABASE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SQL_TYPE_DATABASE))
#define SQL_DATABASE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SQL_TYPE_DATABASE, SqlDatabaseClass))

typedef struct _SqlDatabase SqlDatabase;
typedef struct _SqlDatabaseClass SqlDatabaseClass;

#define TYPE_USER_STREAM (user_stream_get_type ())
#define USER_STREAM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_USER_STREAM, UserStream))
#define USER_STREAM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_USER_STREAM, UserStreamClass))
#define IS_USER_STREAM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_USER_STREAM))
#define IS_USER_STREAM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_USER_STREAM))
#define USER_STREAM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_USER_STREAM, UserStreamClass))

typedef struct _UserStream UserStream;
typedef struct _UserStreamClass UserStreamClass;

#define TYPE_NOTIFICATION_MANAGER (notification_manager_get_type ())
#define NOTIFICATION_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NOTIFICATION_MANAGER, NotificationManager))
#define NOTIFICATION_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NOTIFICATION_MANAGER, NotificationManagerClass))
#define IS_NOTIFICATION_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NOTIFICATION_MANAGER))
#define IS_NOTIFICATION_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NOTIFICATION_MANAGER))
#define NOTIFICATION_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NOTIFICATION_MANAGER, NotificationManagerClass))

typedef struct _NotificationManager NotificationManager;
typedef struct _NotificationManagerClass NotificationManagerClass;
#define _g_free0(var) (var = (g_free (var), NULL))

struct _FilterListEntry {
	GtkListBoxRow parent_instance;
	FilterListEntryPrivate * priv;
};

struct _FilterListEntryClass {
	GtkListBoxRowClass parent_class;
};

struct _FilterListEntryPrivate {
	GtkLabel* content_label;
	GtkRevealer* revealer;
	GtkStack* stack;
	GtkGrid* normal_box;
	GtkBox* delete_box;
	CbFilter* _filter;
	Account* account;
	MainWindow* main_window;
};

struct _Account {
	GObject parent_instance;
	AccountPrivate * priv;
	gint64 id;
	SqlDatabase* db;
	OAuthProxy* proxy;
	UserStream* user_stream;
	CbUserCounter* user_counter;
	NotificationManager* notifications;
	gint64* friends;
	gint friends_length1;
	gint64* blocked;
	gint blocked_length1;
	gint64* muted;
	gint muted_length1;
	gint64* disabled_rts;
	gint disabled_rts_length1;
	GPtrArray* filters;
};

struct _AccountClass {
	GObjectClass parent_class;
};


static gpointer filter_list_entry_parent_class = NULL;

GType filter_list_entry_get_type (void) G_GNUC_CONST;
GType account_get_type (void) G_GNUC_CONST;
GType main_window_get_type (void) G_GNUC_CONST;
#define FILTER_LIST_ENTRY_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_FILTER_LIST_ENTRY, FilterListEntryPrivate))
enum  {
	FILTER_LIST_ENTRY_DUMMY_PROPERTY,
	FILTER_LIST_ENTRY_FILTER,
	FILTER_LIST_ENTRY_CONTENT
};
FilterListEntry* filter_list_entry_new (CbFilter* f, Account* account, MainWindow* main_window);
FilterListEntry* filter_list_entry_construct (GType object_type, CbFilter* f, Account* account, MainWindow* main_window);
void filter_list_entry_set_filter (FilterListEntry* self, CbFilter* value);
static void filter_list_entry_menu_button_clicked_cb (FilterListEntry* self);
static void _filter_list_entry_menu_button_clicked_cb_gtk_button_clicked (GtkButton* _sender, gpointer self);
static void filter_list_entry_cancel_button_clicked_cb (FilterListEntry* self);
static void _filter_list_entry_cancel_button_clicked_cb_gtk_button_clicked (GtkButton* _sender, gpointer self);
static void filter_list_entry_delete_button_clicked_cb (FilterListEntry* self);
GType sql_database_get_type (void) G_GNUC_CONST;
GType user_stream_get_type (void) G_GNUC_CONST;
GType notification_manager_get_type (void) G_GNUC_CONST;
CbFilter* filter_list_entry_get_filter (FilterListEntry* self);
void sql_database_exec (SqlDatabase* self, const gchar* sql, sqlite3_callback callback, void* callback_target);
void main_window_rerun_filters (MainWindow* self);
static void _filter_list_entry_delete_button_clicked_cb_gtk_button_clicked (GtkButton* _sender, gpointer self);
const gchar* filter_list_entry_get_content (FilterListEntry* self);
void filter_list_entry_set_content (FilterListEntry* self, const gchar* value);
static GObject * filter_list_entry_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
static void _filter_list_entry___lambda180_ (FilterListEntry* self);
static void __filter_list_entry___lambda180__g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self);
static void filter_list_entry_finalize (GObject* obj);
static void _vala_filter_list_entry_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_filter_list_entry_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


FilterListEntry* filter_list_entry_construct (GType object_type, CbFilter* f, Account* account, MainWindow* main_window) {
	FilterListEntry * self = NULL;
	CbFilter* _tmp0_ = NULL;
	Account* _tmp1_ = NULL;
	MainWindow* _tmp2_ = NULL;
	g_return_val_if_fail (CB_IS_FILTER (f), NULL);
	g_return_val_if_fail (IS_ACCOUNT (account), NULL);
	g_return_val_if_fail (IS_MAIN_WINDOW (main_window), NULL);
	self = (FilterListEntry*) g_object_new (object_type, NULL);
	_tmp0_ = f;
	filter_list_entry_set_filter (self, _tmp0_);
	_tmp1_ = account;
	self->priv->account = _tmp1_;
	_tmp2_ = main_window;
	self->priv->main_window = _tmp2_;
	return self;
}


FilterListEntry* filter_list_entry_new (CbFilter* f, Account* account, MainWindow* main_window) {
	return filter_list_entry_construct (TYPE_FILTER_LIST_ENTRY, f, account, main_window);
}


static void filter_list_entry_menu_button_clicked_cb (FilterListEntry* self) {
	GtkStack* _tmp0_ = NULL;
	GtkBox* _tmp1_ = NULL;
	g_return_if_fail (IS_FILTER_LIST_ENTRY (self));
	_tmp0_ = self->priv->stack;
	_tmp1_ = self->priv->delete_box;
	gtk_stack_set_visible_child (_tmp0_, G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, gtk_widget_get_type (), GtkWidget));
	gtk_list_box_row_set_activatable (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_list_box_row_get_type (), GtkListBoxRow), FALSE);
}


static void _filter_list_entry_menu_button_clicked_cb_gtk_button_clicked (GtkButton* _sender, gpointer self) {
	filter_list_entry_menu_button_clicked_cb ((FilterListEntry*) self);
}


static void filter_list_entry_cancel_button_clicked_cb (FilterListEntry* self) {
	GtkStack* _tmp0_ = NULL;
	GtkGrid* _tmp1_ = NULL;
	g_return_if_fail (IS_FILTER_LIST_ENTRY (self));
	_tmp0_ = self->priv->stack;
	_tmp1_ = self->priv->normal_box;
	gtk_stack_set_visible_child (_tmp0_, G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, gtk_widget_get_type (), GtkWidget));
	gtk_list_box_row_set_activatable (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_list_box_row_get_type (), GtkListBoxRow), TRUE);
}


static void _filter_list_entry_cancel_button_clicked_cb_gtk_button_clicked (GtkButton* _sender, gpointer self) {
	filter_list_entry_cancel_button_clicked_cb ((FilterListEntry*) self);
}


static gint g_ptr_array_get_length (GPtrArray* self) {
	gint result;
	guint _tmp0_ = 0U;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->len;
	result = (gint) _tmp0_;
	return result;
}


static void g_ptr_array_set_length (GPtrArray* self, gint value) {
	gint _tmp0_ = 0;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	g_ptr_array_set_size (self, _tmp0_);
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static void filter_list_entry_delete_button_clicked_cb (FilterListEntry* self) {
	g_return_if_fail (IS_FILTER_LIST_ENTRY (self));
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				gint _tmp2_ = 0;
				Account* _tmp3_ = NULL;
				GPtrArray* _tmp4_ = NULL;
				gint _tmp5_ = 0;
				gint _tmp6_ = 0;
				CbFilter* f = NULL;
				Account* _tmp7_ = NULL;
				GPtrArray* _tmp8_ = NULL;
				gint _tmp9_ = 0;
				gconstpointer _tmp10_ = NULL;
				CbFilter* _tmp11_ = NULL;
				CbFilter* _tmp12_ = NULL;
				gint _tmp13_ = 0;
				CbFilter* _tmp14_ = NULL;
				CbFilter* _tmp15_ = NULL;
				gint _tmp16_ = 0;
				if (!_tmp0_) {
					gint _tmp1_ = 0;
					_tmp1_ = i;
					i = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				_tmp2_ = i;
				_tmp3_ = self->priv->account;
				_tmp4_ = _tmp3_->filters;
				_tmp5_ = g_ptr_array_get_length (_tmp4_);
				_tmp6_ = _tmp5_;
				if (!(_tmp2_ < _tmp6_)) {
					break;
				}
				_tmp7_ = self->priv->account;
				_tmp8_ = _tmp7_->filters;
				_tmp9_ = i;
				_tmp10_ = g_ptr_array_index (_tmp8_, (guint) _tmp9_);
				_tmp11_ = _g_object_ref0 ((CbFilter*) _tmp10_);
				f = _tmp11_;
				_tmp12_ = f;
				_tmp13_ = cb_filter_get_id (_tmp12_);
				_tmp14_ = filter_list_entry_get_filter (self);
				_tmp15_ = _tmp14_;
				_tmp16_ = cb_filter_get_id (_tmp15_);
				if (_tmp13_ == _tmp16_) {
					Account* _tmp17_ = NULL;
					GPtrArray* _tmp18_ = NULL;
					CbFilter* _tmp19_ = NULL;
					Account* _tmp20_ = NULL;
					SqlDatabase* _tmp21_ = NULL;
					CbFilter* _tmp22_ = NULL;
					gint _tmp23_ = 0;
					gchar* _tmp24_ = NULL;
					gchar* _tmp25_ = NULL;
					GtkRevealer* _tmp26_ = NULL;
					MainWindow* _tmp27_ = NULL;
					_tmp17_ = self->priv->account;
					_tmp18_ = _tmp17_->filters;
					_tmp19_ = f;
					g_ptr_array_remove (_tmp18_, _tmp19_);
					_tmp20_ = self->priv->account;
					_tmp21_ = _tmp20_->db;
					_tmp22_ = f;
					_tmp23_ = cb_filter_get_id (_tmp22_);
					_tmp24_ = g_strdup_printf ("DELETE FROM `filters` WHERE `id`='%d'", _tmp23_);
					_tmp25_ = _tmp24_;
					sql_database_exec (_tmp21_, _tmp25_, NULL, NULL);
					_g_free0 (_tmp25_);
					_tmp26_ = self->priv->revealer;
					gtk_revealer_set_reveal_child (_tmp26_, FALSE);
					_tmp27_ = self->priv->main_window;
					main_window_rerun_filters (_tmp27_);
					_g_object_unref0 (f);
					return;
				}
				_g_object_unref0 (f);
			}
		}
	}
}


static void _filter_list_entry_delete_button_clicked_cb_gtk_button_clicked (GtkButton* _sender, gpointer self) {
	filter_list_entry_delete_button_clicked_cb ((FilterListEntry*) self);
}


CbFilter* filter_list_entry_get_filter (FilterListEntry* self) {
	CbFilter* result;
	CbFilter* _tmp0_ = NULL;
	g_return_val_if_fail (IS_FILTER_LIST_ENTRY (self), NULL);
	_tmp0_ = self->priv->_filter;
	result = _tmp0_;
	return result;
}


void filter_list_entry_set_filter (FilterListEntry* self, CbFilter* value) {
	GtkLabel* _tmp0_ = NULL;
	CbFilter* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	CbFilter* _tmp3_ = NULL;
	g_return_if_fail (IS_FILTER_LIST_ENTRY (self));
	_tmp0_ = self->priv->content_label;
	_tmp1_ = value;
	_tmp2_ = cb_filter_get_contents (_tmp1_);
	gtk_label_set_label (_tmp0_, _tmp2_);
	_tmp3_ = value;
	self->priv->_filter = _tmp3_;
	g_object_notify ((GObject *) self, "filter");
}


const gchar* filter_list_entry_get_content (FilterListEntry* self) {
	const gchar* result;
	GtkLabel* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	g_return_val_if_fail (IS_FILTER_LIST_ENTRY (self), NULL);
	_tmp0_ = self->priv->content_label;
	_tmp1_ = gtk_label_get_label (_tmp0_);
	_tmp2_ = _tmp1_;
	result = _tmp2_;
	return result;
}


void filter_list_entry_set_content (FilterListEntry* self, const gchar* value) {
	GtkLabel* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	g_return_if_fail (IS_FILTER_LIST_ENTRY (self));
	_tmp0_ = self->priv->content_label;
	_tmp1_ = value;
	gtk_label_set_label (_tmp0_, _tmp1_);
	g_object_notify ((GObject *) self, "content");
}


static void _filter_list_entry___lambda180_ (FilterListEntry* self) {
	GtkRevealer* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	_tmp0_ = self->priv->revealer;
	_tmp1_ = gtk_revealer_get_child_revealed (_tmp0_);
	_tmp2_ = _tmp1_;
	if (!_tmp2_) {
		GtkContainer* _tmp3_ = NULL;
		_tmp3_ = (GtkContainer*) gtk_widget_get_parent (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget));
		gtk_container_remove (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, gtk_container_get_type (), GtkContainer), G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget));
	}
}


static void __filter_list_entry___lambda180__g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self) {
	_filter_list_entry___lambda180_ ((FilterListEntry*) self);
}


static GObject * filter_list_entry_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	GObjectClass * parent_class;
	FilterListEntry * self;
	GtkRevealer* _tmp0_ = NULL;
	parent_class = G_OBJECT_CLASS (filter_list_entry_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_FILTER_LIST_ENTRY, FilterListEntry);
	_tmp0_ = self->priv->revealer;
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, G_TYPE_OBJECT, GObject), "notify::child-revealed", (GCallback) __filter_list_entry___lambda180__g_object_notify, self, 0);
	return obj;
}


static void filter_list_entry_class_init (FilterListEntryClass * klass) {
	gint FilterListEntry_private_offset;
	filter_list_entry_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (FilterListEntryPrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_filter_list_entry_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_filter_list_entry_set_property;
	G_OBJECT_CLASS (klass)->constructor = filter_list_entry_constructor;
	G_OBJECT_CLASS (klass)->finalize = filter_list_entry_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), FILTER_LIST_ENTRY_FILTER, g_param_spec_object ("filter", "filter", "filter", CB_TYPE_FILTER, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), FILTER_LIST_ENTRY_CONTENT, g_param_spec_string ("content", "content", "content", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	FilterListEntry_private_offset = g_type_class_get_instance_private_offset (klass);
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/org/baedert/corebird/ui/filter-list-entry.ui");
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "content_label", FALSE, FilterListEntry_private_offset + G_STRUCT_OFFSET (FilterListEntryPrivate, content_label));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "revealer", FALSE, FilterListEntry_private_offset + G_STRUCT_OFFSET (FilterListEntryPrivate, revealer));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "stack", FALSE, FilterListEntry_private_offset + G_STRUCT_OFFSET (FilterListEntryPrivate, stack));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "normal_box", FALSE, FilterListEntry_private_offset + G_STRUCT_OFFSET (FilterListEntryPrivate, normal_box));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "delete_box", FALSE, FilterListEntry_private_offset + G_STRUCT_OFFSET (FilterListEntryPrivate, delete_box));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "menu_button_clicked_cb", G_CALLBACK(_filter_list_entry_menu_button_clicked_cb_gtk_button_clicked));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "cancel_button_clicked_cb", G_CALLBACK(_filter_list_entry_cancel_button_clicked_cb_gtk_button_clicked));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "delete_button_clicked_cb", G_CALLBACK(_filter_list_entry_delete_button_clicked_cb_gtk_button_clicked));
}


static void filter_list_entry_instance_init (FilterListEntry * self) {
	self->priv = FILTER_LIST_ENTRY_GET_PRIVATE (self);
	gtk_widget_init_template (GTK_WIDGET (self));
}


static void filter_list_entry_finalize (GObject* obj) {
	FilterListEntry * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_FILTER_LIST_ENTRY, FilterListEntry);
	_g_object_unref0 (self->priv->content_label);
	_g_object_unref0 (self->priv->revealer);
	_g_object_unref0 (self->priv->stack);
	_g_object_unref0 (self->priv->normal_box);
	_g_object_unref0 (self->priv->delete_box);
	G_OBJECT_CLASS (filter_list_entry_parent_class)->finalize (obj);
}


GType filter_list_entry_get_type (void) {
	static volatile gsize filter_list_entry_type_id__volatile = 0;
	if (g_once_init_enter (&filter_list_entry_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (FilterListEntryClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) filter_list_entry_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FilterListEntry), 0, (GInstanceInitFunc) filter_list_entry_instance_init, NULL };
		GType filter_list_entry_type_id;
		filter_list_entry_type_id = g_type_register_static (gtk_list_box_row_get_type (), "FilterListEntry", &g_define_type_info, 0);
		g_once_init_leave (&filter_list_entry_type_id__volatile, filter_list_entry_type_id);
	}
	return filter_list_entry_type_id__volatile;
}


static void _vala_filter_list_entry_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	FilterListEntry * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_FILTER_LIST_ENTRY, FilterListEntry);
	switch (property_id) {
		case FILTER_LIST_ENTRY_FILTER:
		g_value_set_object (value, filter_list_entry_get_filter (self));
		break;
		case FILTER_LIST_ENTRY_CONTENT:
		g_value_set_string (value, filter_list_entry_get_content (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_filter_list_entry_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	FilterListEntry * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_FILTER_LIST_ENTRY, FilterListEntry);
	switch (property_id) {
		case FILTER_LIST_ENTRY_FILTER:
		filter_list_entry_set_filter (self, g_value_get_object (value));
		break;
		case FILTER_LIST_ENTRY_CONTENT:
		filter_list_entry_set_content (self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



